/*
 * Copyright (C) 2003-2007 Funambol, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
 */

// NotesSettingsAdvanced.cpp : implementation file
//

#include "stdafx.h"
#include "NotesSettingsAdvanced.h"
#include "comutil.h"
#include "pim/clientsettings.h"
#include "pim/Maincpp.h"

#include "comutil.h"

// CNotesSettingsAdvanced dialog

IMPLEMENT_DYNAMIC(CNotesSettingsAdvanced, CDialog)

#if defined(WIN32_PLATFORM_PSPC)
CNotesSettingsAdvanced::CNotesSettingsAdvanced(CWnd* pParent /*=NULL*/)
	: CDialog(CNotesSettingsAdvanced::IDD, pParent)
{

}
#endif

CNotesSettingsAdvanced::~CNotesSettingsAdvanced(){
  #if defined(WIN32_PLATFORM_PSPC)
    editRemote.Detach();
  #endif
}

void CNotesSettingsAdvanced::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
    #if defined(WIN32_PLATFORM_PSPC)
        DDX_Control(pDX, IDC_NOTES_EDIT_REMOTE, editRemote);
    #endif
}

BOOL CNotesSettingsAdvanced::OnInitDialog(){
  #if defined(WIN32_PLATFORM_PSPC)
    CString s1;

    s1.LoadString(IDS_ADVANCED_NOTES); SetWindowText(s1);
    CDialog::OnInitDialog();

    // menubar
    ZeroMemory(&dlgCommandBar, sizeof(SHMENUBARINFO));
    dlgCommandBar.cbSize = sizeof(SHMENUBARINFO);
    dlgCommandBar.hwndParent = this->GetSafeHwnd();
    dlgCommandBar.dwFlags = SHCMBF_HMENU;
    dlgCommandBar.nToolBarId = IDM_OKCANCEL;
    dlgCommandBar.hInstRes = ::AfxGetInstanceHandle();
    dlgCommandBar.nBmpId = 0;
    dlgCommandBar.cBmpImages = 0;
    if(!SHCreateMenuBar(&dlgCommandBar)){
        TRACE(_T("Cannot create command bar!"));
        return FALSE;
    }

   editRemote.SetLimitText(EDIT_MAXLENGTH);
   LoadStringResources();

   // set font
   LOGFONT lf;
   memset(&lf, 0, sizeof(LOGFONT));
   HFONT hFont = (HFONT) GetStockObject(SYSTEM_FONT);
   GetObject(hFont, sizeof lf, &lf);
   lf.lfWeight = FW_BOLD;
   lf.lfHeight +=FONT_HEIGHT_OFFSET;
   VERIFY(fontBold.CreateFontIndirect(&lf));

   GetDlgItem(IDC_NOTES_STATIC_REMONAME)->SetFont(&fontBold);
   // set ppc header
   #if defined(WIN32_PLATFORM_PSPC)
        s1.LoadString(IDS_ADVANCED_NOTES); SetDlgItemText(IDC_HEADER_STATIC, s1);
        GetDlgItem(IDC_HEADER_STATIC)->SetFont(&fontBold);
    #endif

   WindowsSyncSourceConfig* ssconf = getRegConfig()->getWinSyncSourceConfig("note");
   s1 = ssconf->getURI(); SetDlgItemText(IDC_NOTES_EDIT_REMOTE,s1);

   editRemote.SetSel(LARGE_INT ,LARGE_INT);
   editRemote.SetFocus();
 #endif

   return FALSE;
}

void CNotesSettingsAdvanced::OnOK(){
 #if defined(WIN32_PLATFORM_PSPC)
    WindowsSyncSourceConfig* ssconf = getRegConfig()->getWinSyncSourceConfig("note");
    CString s1;
    _bstr_t bst;

    if(checkStartSync()){
        CDialog::OnOK();
    };

    GetDlgItemText(IDC_NOTES_EDIT_REMOTE, s1);
    bst=s1.AllocSysString();
    if(strcmp((char*)bst,ssconf->getURI()) != 0){
        ssconf->setURI((char*)bst);


        getRegConfig()->setDirty(CS_DIRTY_SOURCE_NOTES);
        getRegConfig()->saveDirty();
    }
    bst.Detach();
    CDialog::OnOK();
 #endif
}

void CNotesSettingsAdvanced::LoadStringResources(){
    CString s1;
    #if defined(WIN32_PLATFORM_PSPC)
        s1.LoadString(IDS_REMOTENAME); SetDlgItemText(IDC_NOTES_STATIC_REMONAME,s1);
        s1.LoadString(IDS_ADVANCED_NOTES); SetDlgItemText(IDC_HEADER_STATIC, s1);
    #endif
}

BEGIN_MESSAGE_MAP(CNotesSettingsAdvanced, CDialog)
    ON_WM_CTLCOLOR()
END_MESSAGE_MAP()


// CNotesSettingsAdvanced message handlers
HBRUSH CNotesSettingsAdvanced::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) {
    HBRUSH hbr = CDialog::OnCtlColor(pDC, pWnd, nCtlColor);

    // set ppc header text color
    #if defined(WIN32_PLATFORM_PSPC)
    if(pWnd->GetDlgCtrlID() == IDC_HEADER_STATIC) {
        pDC->SetBkMode(TRANSPARENT);
        pDC->SetTextColor(PPC_HEADER_TEXT_COLOR);
    }
    #endif

    return hbr;
}