/*
 * Copyright (C) 2003-2007 Funambol, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
 */

// PushCheck.cpp : implementation file
//

#include "stdafx.h"
#include "PushCheck.h"
#include "notify/checknet.h"

// CPushCheck dialog

IMPLEMENT_DYNAMIC(CPushCheck, CDialog)

CPushCheck::CPushCheck(CWnd* pParent /*=NULL*/)
	: CDialog(CPushCheck::IDD, pParent)
{

}

CPushCheck::~CPushCheck()
{
}

void CPushCheck::DoDataExchange(CDataExchange* pDX){
	CDialog::DoDataExchange(pDX);
}

BOOL CPushCheck::OnInitDialog(){
    CString s1;

    CDialog::OnInitDialog();

    s1.LoadString(IDS_PUSH_CHECKING_NETWORK); SetDlgItemText(IDC_PUSH_STATIC_CHECKING,s1);

    LOGFONT lf;
    memset(&lf, 0, sizeof(LOGFONT));
    HFONT hFont = (HFONT) GetStockObject(SYSTEM_FONT);
    GetObject(hFont, sizeof lf, &lf);
    lf.lfWeight = FW_BOLD;
    lf.lfHeight +=FONT_HEIGHT_OFFSET;
    VERIFY(fontBold.CreateFontIndirect(&lf));

    GetDlgItem(IDC_PUSH_STATIC_CHECKING)->SetFont(&fontBold);

    SHMENUBARINFO dlgCommandBar;
    ZeroMemory(&dlgCommandBar, sizeof(SHMENUBARINFO));
    dlgCommandBar.cbSize = sizeof(SHMENUBARINFO);
    dlgCommandBar.hwndParent = this->GetSafeHwnd();
    dlgCommandBar.dwFlags = SHCMBF_HMENU;
    dlgCommandBar.nToolBarId = IDM_OKCANCEL;
    #if defined WIN32_PLATFORM_WFSP
    #if (_WIN32_WCE < 0x500)
        dlgCommandBar.nToolBarId = IDR_MENUBAR_OKCANCEL;
    #endif
    #endif
    dlgCommandBar.hInstRes = ::AfxGetInstanceHandle();
    dlgCommandBar.nBmpId = 0;
    dlgCommandBar.cBmpImages = 0;
    if(!SHCreateMenuBar(&dlgCommandBar)){
        TRACE(_T("Cannot create command bar!"));
        return FALSE;
    };


    TBBUTTONINFO tbi;

    memset (&tbi, 0, sizeof (tbi));
    tbi.cbSize = sizeof (tbi);
    tbi.dwMask = TBIF_STATE;
    ::SendMessage (dlgCommandBar.hwndMB, TB_GETBUTTONINFO, IDOK, (LPARAM)&tbi);
    tbi.fsState &= ~TBSTATE_ENABLED;
    ::SendMessage (dlgCommandBar.hwndMB, TB_SETBUTTONINFO, IDOK, (LPARAM)&tbi);

    memset (&tbi, 0, sizeof (tbi));
    tbi.cbSize = sizeof (tbi);
    tbi.dwMask = TBIF_STATE;
    ::SendMessage (dlgCommandBar.hwndMB, TB_GETBUTTONINFO, IDCANCEL, (LPARAM)&tbi);
    tbi.fsState &= ~TBSTATE_ENABLED;
    ::SendMessage (dlgCommandBar.hwndMB, TB_SETBUTTONINFO, IDCANCEL, (LPARAM)&tbi);

    SetTimer(1000, 100, NULL);

    return FALSE;
}

BEGIN_MESSAGE_MAP(CPushCheck, CDialog)
    ON_WM_TIMER()
END_MESSAGE_MAP()


// CPushCheck message handlers

void CPushCheck::OnTimer( UINT_PTR nIDEvent ){
    KillTimer(1000);

    if(checkNetwork())
        EndDialog(PUSH_NETWORK_AVAILABLE);
    else
        EndDialog(PUSH_NETWORK_UNAVAILABLE);
}
