/*
 * Copyright (C) 2003-2007 Funambol, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
 */

#pragma once
#include "afxwin.h"
#include "CustomButton.h"

// CBriefcaseSettings dialog

class CBriefcaseSettings : public CDialog
{
	DECLARE_DYNAMIC(CBriefcaseSettings)

public:
	CBriefcaseSettings(CWnd* pParent = NULL);   // standard constructor
	virtual ~CBriefcaseSettings();

	// Dialog Data
	enum { IDD = IDD_UI_BRIEFCASE };

protected:
    #if defined(WIN32_PLATFORM_PSPC)
        CComboBox lstSyncType;
    #endif

    #if defined(WIN32_PLATFORM_WFSP)
        CListBox lstSyncType;
        CSpinButtonCtrl spinSyncType;
    #endif

    SHMENUBARINFO dlgCommandBar;
    CFont fontBold;
    CString folder;
    CCustomButton linkAdvanced;
    CCustomButton linkChoose;

    #if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
        afx_msg void OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/);
    #endif

	virtual BOOL OnInitDialog();
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    virtual BOOL PreTranslateMessage(MSG* pMsg);

	DECLARE_MESSAGE_MAP()

    afx_msg void OnOK();

    /**
     * opens dialog for choosing the folder to be synced,
     * upon return modifies folder attribute
     */
    afx_msg void OnMenuFolder();

    /**
     * opens Advanced briefcase dialog
     */
    afx_msg void OnBnClickedBriefcaseLinkAdvanced();

    /**
    * when 'Choose..' link is activated, executes OnMenuFolder
    * @see: OnMenuFolder
    */
    afx_msg void OnBnClickedBriefcaseLinkChoose();

    HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
};
