/*
 * Copyright (C) 2003-2007 Funambol, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
 */

#ifndef _INCL_UI_CLIENT_UTIL
#define _INCL_UI_CLIENT_UTIL


#define STRING_MAXLENGTH 300
#define LARGE_INT 32000
#define CLOSE_THIS_DIALOG 222

/**
 * the format in which the last sync time appears in the main window,
 * used by CTime::Format()
 */
#define LAST_SYNC_TIME_FORMAT TEXT("%b %#d %#I:%M%p")

/**
 * tranforms sync type notation from registry to UI, index pos in listbox
 * @param sSyncType : sync type in Registry format
 * @return the index where this sync type should be in listbox (starts from 0)
 */
int SynctypeReg2UI(const char* sSyncType);

/**
 * tranforms sync type notation from UI to Registry, index pos in listbox
 * @param pos :  position in listbox (starts from 0)
 */
const char* SynctypeUI2Reg(int nPos);

/**
 * checks if the sync is in progress, if yes queries the user if he wants to stop it,
 * if the user chooses yes then the sync is stopped
 * @param : the window handle of a window to we want to attach the timed msgbox, if NULL the msgbox will have no parent
 * @return: -1 if the user chose NO, 0 if the user chose YES, 1 if the sync is not running thus the msgbox wasn't displayed
 */
int EndAppQuery(HWND);

/**
 * checks if a folder exists
 * @param: the folder to be checked
 * @return: TRUE if dir exists, FALSE otherwise
 */
BOOL existsDirectory(wchar_t* dir);
#endif