/*
 * Copyright (C) 2003-2007 Funambol, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
 */
#pragma once

#include "ui.h"
#include "afxwin.h"
// CCommunicationSettings dialog

class CCommunicationSettings : public CDialog
{
   DECLARE_DYNAMIC(CCommunicationSettings)

public:
   CCommunicationSettings(CWnd* pParent = NULL);   // standard constructor
   virtual ~CCommunicationSettings();

// Dialog Data
	enum { IDD = IDD_UI_COMM };

protected:
   SHMENUBARINFO dlgCommandBar;
   CEdit editUrl;
   CEdit editUser;
   CEdit editPassword;
   CFont fontBold;

   /**
    * checks if the input if entered in the dialog is valid
    * @param url : Funambol server url
    * @param username
    * @param password
    * @return  : true if the input is accepted
    */
   bool isInputValid(CString url, CString username, CString password);

   virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

   /**
    *  called on dialog init
    */
   virtual BOOL OnInitDialog();

 DECLARE_MESSAGE_MAP()
public:
   /**
    * called when saving changes
    */
   afx_msg void OnOK();
   HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);

   #if defined(WIN32_PLATFORM_WFSP)
	LRESULT OnHotkey(WPARAM wParam, LPARAM lParam);
   #endif
};
