/*
 * Copyright (C) 2003-2007 Funambol, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
 */

#pragma once
#include "afxwin.h"
#include "CustomButton.h"

class CContactSettings : public CDialog
{
	DECLARE_DYNAMIC(CContactSettings)

public:
	CContactSettings(CWnd* pParent = NULL);   // standard constructor
	virtual ~CContactSettings();

// Dialog Data
	enum { IDD = IDD_UI_CONTACTS };

protected:
    #if defined(WIN32_PLATFORM_PSPC)
        CComboBox lstSyncType;
    #endif

    #if defined(WIN32_PLATFORM_WFSP)
        CListBox lstSyncType;
        CSpinButtonCtrl spinSyncType;
    #endif

    CFont fontBold;
    SHMENUBARINFO dlgCommandBar;
    CCustomButton linkAdvanced;

    /**
     *  loads strings onto the dialog from the stringtable
     */
    void LoadStringResources();

    virtual BOOL OnInitDialog();
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    virtual BOOL PreTranslateMessage(MSG* pMsg);

	DECLARE_MESSAGE_MAP()
    afx_msg void OnOK();

    /**
     *  called when selecting the "Advanced Settings" link
     */
    afx_msg void OnBnClickedContactsLinkAdvanced();

    HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
};
