/*
 * Copyright (C) 2003-2007 Funambol, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
 */

#pragma once


// CContactSettingsAdvanced dialog
#include "ui.h"

class CContactSettingsAdvanced : public CDialog
{
	DECLARE_DYNAMIC(CContactSettingsAdvanced)

public:
	CContactSettingsAdvanced(CWnd* pParent = NULL);   // standard constructor
	virtual ~CContactSettingsAdvanced();

// Dialog Data
	enum { IDD = IDD_UI_CONTACTS_ADVANCED };

    SHMENUBARINFO dlgCommandBar;

    #if defined(WIN32_PLATFORM_PSPC)
        CComboBox lstSyncType;
    #endif

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    virtual BOOL OnInitDialog();

    /**
     * all window message go through here first,
     * overrides default handling for radio buttons focus order
     * @return: TRUE if we have processed the message and we don't want the application to proccess it
     */
    BOOL PreTranslateMessage( MSG* pMsg );

    /**
     * loads strings onto the dialog from the stringtable
     */
    void LoadStringResources();

    CButton radioBut1;
    CButton radioBut2;
    CEdit editRemote;
    CFont fontBold;

	DECLARE_MESSAGE_MAP()
    #ifdef SMARTPHONE2003_UI_MODEL
        /**
        * override default behaviour of BACK key ( <- ), delete characters from editbox instead of going to pre
         */
        LRESULT OnHotkey(WPARAM wParam, LPARAM lParam);
    #endif

    afx_msg void OnOK();
    HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);

};
