/*
 * Copyright (C) 2003-2007 Funambol, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
 */

#pragma once
#include "afxwin.h"

#include <list>
using namespace std;



// CExploreFolders dialog
class CExploreFolders : public CDialog
{
    DECLARE_DYNAMIC(CExploreFolders)

public:
    CExploreFolders(CWnd* pParent = NULL);	// standard constructor
    virtual ~CExploreFolders();

    enum { IDD = IDD_UI_EXPLORE };
protected:

    #if defined(WIN32_PLATFORM_PSPC)
        /**
         *  true if this is to display the folder for notes, if false then it's briefcase
         */
        bool isNotes;

        CFont fontBold;
    #endif

    #if defined(WIN32_PLATFORM_WFSP)
        /**
         * each element in the list is a folder in the path
         */
        list<CString> path;

        bool isRoot;
    #endif

    SHMENUBARINFO dlgCommandBar;

    virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

// Implementation
protected:
    HICON m_hIcon;
    CString folder;

    virtual BOOL OnInitDialog();
    #if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	    afx_msg void OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/);
    #endif

    DECLARE_MESSAGE_MAP()
public:
    afx_msg void OnOK();
    CString getFolder() { return folder;}
    void setFolder(CString value){ folder = value;}

    #if defined(WIN32_PLATFORM_WFSP)
        CListBox lstFiles;
        /**
         *  the folder was chosen by selecting 'Choose' from the menubar
         */
        afx_msg void OnChoose();

        void BrowseFolder();
    #endif

    #if defined(WIN32_PLATFORM_PSPC)
        void setIsNotes(bool value) {isNotes = value; }

        /**
         * events fired when a folder item is expanding/expanded ( for PPC folder tree)
         */
        afx_msg void OnTvnItemExpanded( NMHDR * pNotifyStruct, LRESULT * result );
        afx_msg void OnTvnItemExpanding( NMHDR * pNotifyStruct, LRESULT * result );

        afx_msg void OnTvnSelChanged( NMHDR * pNotifyStruct, LRESULT * result );
        afx_msg void OnTvnDblClk( NMHDR * pNotifyStruct, LRESULT * result );
        HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
    #endif
};
