/*
 * Copyright (C) 2003-2007 Funambol, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
 */

#pragma once

#define ASK_REFRESH_MESSAGE TEXT("Replacing your device's %s with a fresh copy from the server.  Continue?")
#define ASK_REFRESH_MESSAGE_MAILS TEXT("Replacing your device's mail with a fresh copy from the server.  Continue?")
#define ASK_REFRESH_TIMEOUT 30

// Startsync application name
#define SYNCAPP TEXT("startsync.exe")

//#include "ui.h"

/**
 *  Recover dialog
 */
class CRecoverSettings : public CDialog
{
	DECLARE_DYNAMIC(CRecoverSettings)

public:
	CRecoverSettings(CWnd* pParent = NULL);   // standard constructor
	virtual ~CRecoverSettings();

// Dialog Data
	enum { IDD = IDD_UI_RECOVER };

protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    virtual BOOL OnInitDialog();

    SHMENUBARINFO dlgCommandBar;
    CFont fontBold;
    CButton checkContacts;
    CButton checkCalendar;
    CButton checkTasks;
    CButton checkMail;
    CButton checkBriefcase;

    #if defined(WIN32_PLATFORM_PSPC)
        CButton checkNotes;
        CComboBox lstSyncType;
    #endif

    #if defined(WIN32_PLATFORM_WFSP)
        CListBox lstSyncType;
        CSpinButtonCtrl spinSyncType;
    #endif

    #if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
        afx_msg void OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/);
    #endif

    DECLARE_MESSAGE_MAP()
		afx_msg void OnOK();
        void EnableRecoverButton(bool bEnable);
        bool isCheckboxChecked();
public:
    afx_msg void OnBnClickedRecoverMail();
    afx_msg void OnBnClickedRecoverCalendar();
    afx_msg void OnBnClickedRecoverContacts();
    afx_msg void OnBnClickedRecoverTasks();
    afx_msg void OnBnClickedRecoverBriefcase();
    #if defined(WIN32_PLATFORM_PSPC)
        afx_msg void OnBnClickedRecoverNotes();
    #endif

    afx_msg void OnLbnSelchangeRecoverListSynctype();
};
