/*
 * Copyright (C) 2003-2007 Funambol, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
 */

#pragma once

#include "ui.h"
#include "afxcmn.h"
#include "afxwin.h"
#include "CustomButton.h"

/**
 * Sync Settings dialog
 */
class CSyncSettings : public CDialog
{
    DECLARE_DYNAMIC(CSyncSettings)

public:
    CSyncSettings(CWnd* pParent = NULL);   // standard constructor
    virtual ~CSyncSettings();

// Dialog Data
    enum { IDD = IDD_UI_SYNC };

protected:
    CButton checkMail;
    CButton checkCalendar;
    CButton checkContacts;
    CButton checkTasks;
    CButton checkBriefcase;
    CFont fontBold;
    CCustomButton linkAdvanced;
    //CCustomButton linkMail;

    SHMENUBARINFO dlgCommandBar;

    #if defined(WIN32_PLATFORM_PSPC)
        CButton checkNotes;
        CCustomButton butNotes;
    #endif


    CCustomButton butMail;
    CCustomButton butCalendar;
    CCustomButton butContacts;
    CCustomButton butTasks;
    CCustomButton butBriefcase;

    CString source;
    int advanced;

    int checkedSources;

    // enables/disables the right soft key 'Details' button
    //void EnableAdvancedButton(bool bEnable);

    /**
     * loads strings onto the dialog from the stringtable
     */
    void LoadStringResources();

    /**
     * processes key events (arrow keys), overriding the default behaviour
     * @return:true if the message was processed
     */
    bool processKeyEvents(WPARAM key);

    /**
     * overrides default handling of some window events
     * @see : processKeyEvents
     */
    BOOL PreTranslateMessage(MSG* pMsg);

    /**
     * called on dialog init
     */
    virtual BOOL OnInitDialog();

    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    #if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
        afx_msg void OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/);
    #endif

    DECLARE_MESSAGE_MAP()
public:
    /**
     * opens advanced settings window for <source>  sync source
     */
    afx_msg void showAdvanced();

    // TODO: check if needed
    /**
     * when focus is set on a source checkbox
     */
    afx_msg void OnSetfocusSyncContacts();
    afx_msg void OnBnSetfocusSyncCalendar();
    afx_msg void OnBnSetfocusSyncTasks();
    afx_msg void OnBnSetfocusSyncMail();
    afx_msg void OnBnSetfocusSyncBriefcase();

    afx_msg void OnSetFocus( CWnd* pOldWnd  );

    // TODO: check if needed
    afx_msg void OnBnClickedSyncContacts();
    afx_msg void OnBnClickedSyncCalendar();
    afx_msg void OnBnClickedSyncTasks();
    afx_msg void OnBnClickedSyncMail();
    afx_msg void OnBnClickedSyncBriefcase();

    afx_msg void OnOK();

    /**
     * when an 'Advanced..' link for a source was activated
     * takes the user in a window with the advanced settings for that source
     */
    afx_msg void OnClickedSyncButtonMail();
    afx_msg void OnClickedSyncButtonCalendar();
    afx_msg void OnClickedSyncButtonContacts();
    afx_msg void OnClickedSyncButtonTasks();
    afx_msg void OnClickedSyncButtonBriefcase();
    afx_msg void OnClickedSyncButtonNotes();

    #if defined(WIN32_PLATFORM_PSPC)
    afx_msg void OnBnClickedSyncNotes();
        afx_msg void OnBnSetfocusSyncNotes();
    #endif

    /**
     *  'Advanced Settings' link was activated
     */
    afx_msg void OnBnClickedSyncLinkAdvanced();

    // TODO: is empty, check if needed
    afx_msg void OnBnSetfocusSyncLinkAdvanced();
};
