/*
 * Copyright (C) 2003-2007 Funambol, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
 */

#pragma once

#include "ui.h"

// CSyncSettingsAdvanced dialog

class CSyncSettingsAdvanced : public CDialog
{
    DECLARE_DYNAMIC(CSyncSettingsAdvanced)

public:
    CSyncSettingsAdvanced(CWnd* pParent = NULL);   // standard constructor
    virtual ~CSyncSettingsAdvanced();

// Dialog Data
    enum { IDD = IDD_UI_SYNC_ADVANCED };

protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    virtual BOOL OnInitDialog();

    #if defined(WIN32_PLATFORM_PSPC)
        CComboBox lstPolling;
    #endif

    SHMENUBARINFO dlgCommandBar;

    #if defined(WIN32_PLATFORM_WFSP)
        CListBox lstPolling;
        CSpinButtonCtrl spinPolling;
    #endif

    CButton checkEncryption;
    CButton checkCradle;
    CButton checkEnableCompression;
    CFont fontBold;

    // store boolean value, indicates if cradle was enabled when entering the dialog
    bool cradleInitiallyEnabled;
    // store what was the initial selection in the scheduler settings when entering the dialog
    int initialSchedulerSelection;



 DECLARE_MESSAGE_MAP()

    afx_msg void OnOK();
    HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
};
