/*
 * Copyright (C) 2003-2007 Funambol, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
 */
#include "pim/BriefcaseSyncSource.h"
#include "spds/SyncItemStatus.h"
#include "base/util/utils.h"
#include "base/Log.h"
#include "pim/FILEClient2Server.h"
#include "pim/FILEServer2Client.h"
#include "pim/SettingFunctions.h"
#include "pim/Utils.h"

BriefcaseSyncSource::BriefcaseSyncSource(const wchar_t* name, SourceType t, SyncSourceConfig* sc) : FileObjectSyncSource(name, sc) {
    dir = NULL;
    setSourceType(t);
    }

BriefcaseSyncSource::~BriefcaseSyncSource() {
}

void BriefcaseSyncSource::setSourceType(SourceType t) {
    setType(t);
}

/*
* retrieves the dir parameter set by user in which there are the notes to sync

void BriefcaseSyncSource::setDirFromDM() {
    wchar_t dir[128];
    memset(dir, 0, 128*sizeof(wchar_t));
    getSourceParameter (SYNC_NOTES, PROPERTY_SOURCE_SPDM_DIR, dir);

    // the getSourceParameter introduce a \0 at the end of the dir array
    // it is necessary for the vb program
    //
    // to avoid it for c program the last char is dropped (the last is ' ' char)

    dir[wcslen(dir) -1] = 0;


    setDir(dir);

}
*/
ArrayElement* BriefcaseSyncSource::clone() {
    BriefcaseSyncSource* s = new BriefcaseSyncSource(getName(), getType(), &(getConfig()));
    s->setPath(getPath());
    s->setDir(getDir());

    s->assign(*this);

    return s;
}