/*
 * Copyright (C) 2003-2007 Funambol, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
 */
#include "pim/CalendarSyncSource.h"
#include "spds/SyncItemStatus.h"
#include "base/util/utils.h"
#include "base/Log.h"
#include "pim/POOMClient2Server.h"
#include "pim/POOMServer2Client.h"


CalendarSyncSource::CalendarSyncSource(const wchar_t* name, SourceType t, SyncSourceConfig* sc) : WindowsSyncSource(name, sc) {
   setSourceType(t);
}

CalendarSyncSource::~CalendarSyncSource() {
}

void CalendarSyncSource::setSourceType(SourceType t) {
    setType(t);
}

ArrayElement* CalendarSyncSource::clone() {
    CalendarSyncSource* s = new CalendarSyncSource(getName(), getType(), &(getConfig()));
    s->setPath(getPath());

    s->assign(*this);

    return s;
}