/*
 * Copyright (C) 2003-2007 Funambol, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
 */

#include <stdio.h>
#include <windows.h>
#include <Winbase.h>
#include "base/Log.h"
#include "base/util/utils.h"
#include "base/base64.h"

#include "pim/Utils.h"
#include "pim/RecurrenceException.h"

RecurrenceException::RecurrenceException() {
    originalDate = 0;
    start = 0;
    end = 0;
    subject = L"";
    location = L"";
    body = L"";
    busyStatus = 0;

    allDayEvent = FALSE;
    deleted = FALSE;
}

RecurrenceException::~RecurrenceException() {}

void RecurrenceException::setOriginalDate(DATE date) {
    originalDate = date;
    doubleToSystemTime(woriginaldate, originalDate);

}

void RecurrenceException::setStart(DATE date) {
    start = date;
    doubleToSystemTime(wstartdate, start);
}

void RecurrenceException::setEnd(DATE date) {
    end = date;
    doubleToSystemTime(wenddate, end);
}

void RecurrenceException::setSubject(wstring s) {
    subject = s;
}

void RecurrenceException::setLocation(wstring s) {
    location = s;
}

void RecurrenceException::setBody(wstring s) {
    body = s;
}

void RecurrenceException::setAllDayEvent(BOOL s) {
    allDayEvent = s;
}

void RecurrenceException::setIsDeleted(BOOL s) {
    deleted = s;
}

BOOL RecurrenceException::isOriginalEqualsStart() {
    return (int)originalDate == (int)start ? TRUE : FALSE;

}

void RecurrenceException::setBusyStatus(long s) {
    busyStatus = s;
}
