/*
 * Copyright (C) 2003-2007 Funambol, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
 */

#include "events/SyncItemListenerClient.h" //--from clientdll/include

#include "event/SyncItemEvent.h"
//#include "event/SyncItemListener.h"

#include "event/ManageListener.h"
#include "HwndFunctions.h"

SyncItemListenerClient::SyncItemListenerClient()
{
}

SyncItemListenerClient::~SyncItemListenerClient()
{
}

void SyncItemListenerClient::itemAddedByClient(SyncItemEvent &event)
{
    int source = sourceNameToId(event.getSourceName());
    if (HwndFunctions::wnd)
        SendMessage(HwndFunctions::wnd, ID_MYMSG_ITEM_SYNCED_FROM_CLIENT, (WPARAM) source, NULL);
}

void SyncItemListenerClient::itemAddedByServer(SyncItemEvent &event)
{
    int source = sourceNameToId(event.getSourceName());

    if (strcmp(event.getSourceName(), "mail") != 0) {
    if (HwndFunctions::wnd)
        SendMessage(HwndFunctions::wnd, ID_MYMSG_ITEM_SYNCED_FROM_SERVER,(WPARAM) source, NULL );
}
}

void SyncItemListenerClient::itemDeletedByClient(SyncItemEvent &event)
{
    int source = sourceNameToId(event.getSourceName());

    if (HwndFunctions::wnd)
        SendMessage(HwndFunctions::wnd, ID_MYMSG_ITEM_SYNCED_FROM_CLIENT,(WPARAM) source, NULL);
}

void SyncItemListenerClient::itemDeletedByServer(SyncItemEvent &event)
{
    int source = sourceNameToId(event.getSourceName());

    if (strcmp(event.getSourceName(), "mail") != 0) {
    if (HwndFunctions::wnd)
        SendMessage(HwndFunctions::wnd, ID_MYMSG_ITEM_SYNCED_FROM_SERVER,(WPARAM) source, NULL);
}
}

void SyncItemListenerClient::itemUpdatedByClient(SyncItemEvent &event)
{
    int source = sourceNameToId(event.getSourceName());

    if (HwndFunctions::wnd)
        SendMessage(HwndFunctions::wnd, ID_MYMSG_ITEM_SYNCED_FROM_CLIENT, (WPARAM) source, NULL);

}

void SyncItemListenerClient::itemUpdatedByServer(SyncItemEvent &event)
{
    int source = sourceNameToId(event.getSourceName());

    if (strcmp(event.getSourceName(), "mail") != 0) {
    if (HwndFunctions::wnd)
        SendMessage(HwndFunctions::wnd, ID_MYMSG_ITEM_SYNCED_FROM_SERVER,(WPARAM) source, NULL);
}
}
