/*
 * Copyright (C) 2003-2007 Funambol, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
 */
#include "events/SyncListenerClient.h"
#include "event/SyncEvent.h"
#include "event/constants.h"
#include "event/ManageListener.h"

#include "HwndFunctions.h"

SyncListenerClient::SyncListenerClient() : SyncListener()
{
    syncEnds=0;
}

void SyncListenerClient::syncBegin(SyncEvent &event)
{
    HWND wnd = HwndFunctions::getWindowHandle();
    if(wnd)
        SendMessage(wnd, ID_MYMSG_CONNECTING, NULL, NULL);
}

void SyncListenerClient::syncEnd(SyncEvent &event)
{
    HWND wnd = HwndFunctions::getWindowHandle();
    if(wnd)
        SendMessage(wnd, ID_MYMSG_ENDING, NULL, NULL);
}

void SyncListenerClient::syncError(SyncEvent &event) {
}

void SyncListenerClient::sendInitialization(SyncEvent &event) {
}

void SyncListenerClient::sendModifications(SyncEvent &event) {
}

void SyncListenerClient::sendFinalization(SyncEvent &event) {
}
