/*
 * Copyright (C) 2003-2007 Funambol, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
 */

// service.cpp : register and deregister notlstnr service.
//


#include "pim/SettingFunctions.h"
#include "notify/util.h"
#include "notify/timed_msgbox.h"
#include "base/Log.h"
#include "pim/ClientSettings.h"
#include "notify/s4n_service.h"
#include "notify/addresschange.h"

//----------------------------------
bool askConfirm(wchar_t* notificationType)
{
    //
    // insert popup
    //
    // ClientSettings cs(APPLICATION_URI);
    // ClientSettings::getInstance()->readConfig();

    char buf[128];

    if (wcscmp(notificationType, ASK_TCP_IP) == 0) {
        strcpy(buf, ClientSettings::getInstance()->getPush().c_str());
    } else {
        strcpy(buf, ClientSettings::getInstance()->getSms().c_str());
    }
    //
    // possible value 1 and 2.
    // 1 is download auto
    // 2 is ask user
    //
    if (strcmp(buf, "2") == 0) {

        LOG.debug("Confirm needed: user alerted.");

        int val = TimedMessageBox(NULL, ASK_MESSAGE, TEXT("Alert"),
                             MB_YESNO | MB_ICONQUESTION | MB_SETFOREGROUND, ASK_TIMEOUT*1000);

        if (val == IDYES) {
            LOG.debug("User said yes.");
            return true;
        }
        else {
            LOG.debug("User said no.\n");
            return false;
        }
    }
    LOG.debug("Confirm not requested, sync auto.");
    return true;

    /*
    wchar_t buf[128];
    if (wcscmp(notificationType, ASK_TCP_IP) == 0) {
        getClientConfigurationInternal (TEXT(""), PROPERTY_SPDM_PUSH_NOTIFICATION,
                                     buf, FALSE);
    } else {
        getClientConfigurationInternal (TEXT(""), PROPERTY_SPDM_SMS_WAP_PUSH,
                                     buf, FALSE);
    }
    //
    // possible value 1 and 2.
    // 1 is download auto
    // 2 is ask user
    //
    if (wcscmp(buf, TEXT("2")) == 0) {

        LOG.debug("Confirm needed: user alerted.");

        int val = TimedMessageBox(NULL, ASK_MESSAGE, TEXT("Alert"),
                             MB_YESNO | MB_ICONQUESTION | MB_SETFOREGROUND, ASK_TIMEOUT*1000);

        if (val == IDYES) {
            LOG.debug("User said yes.");
            return true;
        }
        else {
            LOG.debug("User said no.\n");
            return false;
        }
    }
    LOG.debug("Confirm not requested, sync auto.");
    return true;
    */
}



bool getAvailability() {

    int ret = 0;
    bool alreadyRegistered = false;

    ret = registerService();
    if (ret == 120) {
        alreadyRegistered = true;
    }

    AN_ResponseCode code = notifyAddressChange(TEXT(APPLICATION_URI));

    if (!alreadyRegistered) {
        deregisterService();
    }

    if (code == AN_AddressAccepted)
        return true;
    else
        return false;

}
