/*
 * Copyright (C) 2003-2007 Funambol, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
 */

#ifndef INCL_HWND_FUNCTIONS
#define INCL_HWND_FUNCTIONS

#include "windows.h"

#define ID_MYMSG_CONNECTING (WM_APP+1)
#define ID_MYMSG_ENDING (WM_APP+2)
#define ID_MYMSG_STARTSYNC_ENDED (WM_APP+3)
#define ID_MYMSG_STARTING_SYNC (WM_APP+4)
#define ID_MYMSG_ENDING_SOURCE (WM_APP+5)
#define ID_MYMSG_STARTING_SOURCE (WM_APP+6)
#define ID_MYMSG_ITEM_SYNCED_FROM_SERVER (WM_APP+7)
#define ID_MYMSG_TOTAL_ITEMS (WM_APP+8)
#define ID_MYMSG_ITEM_SYNCED_FROM_CLIENT (WM_APP+9)
#define ID_MYMSG_SOURCE_STATE (WM_APP+10)

#define SYNCSOURCE_STATE_OK                 1
#define SYNCSOURCE_STATE_NOT_SYNCED         2
#define SYNCSOURCE_STATE_CANCELED           3

#define SOURCE_MAIL 0
#define SOURCE_CONTACTS 1
#define SOURCE_CALENDAR 2
#define SOURCE_TASKS 3
#define SOURCE_BRIEFCASE 5
#define SOURCE_NOTES 4


class HwndFunctions
{
    public:
        // FIXME: make them private!
      static HWND wnd;
      static HWND wndMsgBox;
      //static HWND wndAccountWindow;

      static void findFunambolWindow();
      static void initHwnd();
      static HWND getWindowHandle();
      //static HWND getAccountWindowHandle();
      static void closePreviousMsgBox();
};

int sourceNameToId(const char* sourceName);
const char* sourceIdToName(const char* sourceName);

#endif