/*
 * Copyright (C) 2003-2007 Funambol, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
 */


#ifndef __ADDRESSCHANGE_H
#define __ADDRESSCHANGE_H

#include "base/fscapi.h"
#include "base/util/StringBuffer.h"
#include "spds/SyncItem.h"
#include "spds/SyncStatus.h"
#include "spds/SyncSource.h"
#include "notify/AddressChangeSyncSource.h"

#define ADDR_CHANGE_SOURCE_NAME "addresschange"

// This SyncSource is used only to send the ipaddress and msisdn
// in the Alert message to the server.
class AddressChangeSyncSource : public SyncSource {

  public:

    AddressChangeSyncSource(const wchar_t* name, SyncSourceConfig* config) ;

    SyncItem* getFirstItem() ;
    SyncItem* getNextItem() ;
    SyncItem* getFirstNewItem() ;
    SyncItem* getNextNewItem() ;
    SyncItem* getFirstUpdatedItem()  ;
    SyncItem* getNextUpdatedItem() ;
    SyncItem* getFirstDeletedItem() ;
    SyncItem* getNextDeletedItem() ;
    void setItemStatus(const wchar_t* key, int status) ;
    int addItem(SyncItem& item) ;
    int updateItem(SyncItem& item) ;
    int deleteItem(SyncItem& item) ;

    int beginSync() ;
    int endSync() ;

    ArrayElement* clone();

    SyncItem *getFirstItemKey();
    SyncItem *getNextItemKey(void);
};

// Set a new MS-ISDN number
void setMSIsdn(const char *val);

// Get the current MS-ISDN number
const char * getMSIsdn();


#endif

