/*
 * Copyright (C) 2003-2007 Funambol, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
 */
#ifndef __NOTIFY_UTIL_H
#define __NOTIFY_UTIL_H

// Message to display to ask confirmation before synching
#define ASK_MESSAGE L"The server has notified that new data is available. " \
                    L"Do you want to synchronize now?"
// Seconds to display the message to the user
#define ASK_TIMEOUT 10

/*
* The constants are used for notification listener and for sms wap push.
* So it is possible look at the right parameter into dm to understand which
* kind of sync has to be performed
*/

#define ASK_TCP_IP      TEXT("tcp_ip")
#define ASK_WAP_PUSH    TEXT("wap_push")

bool askConfirm(wchar_t* notificationType);
bool getAvailability();

#endif

