/*
 * Copyright (C) 2003-2007 Funambol, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
 */


//
// @author Marco Magistrali
//

#ifndef INCL_APPOINTMENT_BUILDER
#define INCL_APPOINTMENT_BUILDER

    #include "pimstore.h"
    #include "pim/Utils.h"
    #include "pim/crc32.h"
    #include "vocl/VObject.h"

    #include <string>
    using namespace std;

    void populateAppointmentStringItem(wstring &appointmentStringItem, IAppointment *pAppointment, BOOL isCRC = FALSE);
    void completeAppointment(IAppointment *pAppointment, wchar_t *ptrData, IPOutlookApp* polApp, wchar_t* path);
    void normalizeAppointment(IPOutlookApp *polApp, int dataType, wchar_t* path);
    long calculateAppointmentHash (IAppointment* pAppointment);
    BOOL isAllDayEvent(DATE start, DATE end);
    //BOOL isDateForAllDayEventFormat(wchar_t* stringDate);
    VObject* AppointmentToVObject(IAppointment *pAppointment);
    void VObjectToAppointment(IAppointment *pAppointment, VObject *vo);
    long calculateDayOfWeek(wchar_t* in);
    bool isDayOfWeek(wchar_t* string);
    long getWeekDay(DATE dt);
    wchar_t* extractDayOfWeek(long l);

    wstring createExceptions(IRecurrencePattern* pRecurrence);
    wstring createException(IException* pException);

    BOOL normalizeAppointmentExceptions(IPOutlookApp* polApp);

#endif