/*
 * Copyright (C) 2003-2007 Funambol, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
 */

#ifndef INCL_CALENDAR_SYNC_SOURCE
#define INCL_CALENDAR_SYNC_SOURCE

#include "base/fscapi.h"
#include "base/util/ArrayElement.h"
#include "spds/constants.h"
#include "spds/SyncItem.h"
#include "spds/SyncMap.h"
#include "spds/SyncStatus.h"
#include "pim/WindowsSyncSource.h"
#include "pim/Container.h"

class  CalendarSyncSource : public WindowsSyncSource {

public:

    /**
     * Constructor: create a SyncSource with the specified name
     *
     * @param name - the name of the SyncSource
     */
    CalendarSyncSource(const wchar_t* name, SourceType t, SyncSourceConfig* sc);

    void setSourceType(SourceType t);

    // TestSyncSource
    ~CalendarSyncSource();

    ArrayElement* clone();
};

#endif
