/*
 * Copyright (C) 2003-2007 Funambol, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
 */

#ifndef INCL_CUSTOM_SYNC_CLIENT
#define INCL_CUSTOM_SYNC_CLIENT

#include "client/SyncClient.h"

#include <vector>
#include <string>
using namespace std;

class  CustomSyncClient : public SyncClient {

public:

    // they are the sync modes and the source name that come from the syncmanager
    vector<long> modes;
    vector<wstring> sourcenames;

    // they are the previous sync modes and the name of sources that are created before the sync
    vector<long> syncTypes;
    vector<wstring> namesOfSources;

    /*
    * if it is a inclusive mail we don't want permit a slow sync. So we stop the sync
    */
    BOOL isMailInclusive;

    CustomSyncClient();

    ~CustomSyncClient();

    virtual int continueAfterPrepareSync();

};

#endif
