/*
 * Copyright (C) 2003-2007 Funambol, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
 */

//
// @author Marco Magistrali
//
#ifndef INCL_FILEFILEMANAGEMENT
    #define INCL_FILEFILEMANAGEMENT

    #define DIMLINE 512

    int writeTextToFile(wchar_t* filename, wchar_t* text);

    wchar_t* readTextFromBinaryFile(wchar_t* filename);

    void writeTextToTextFile(wchar_t* fName, wchar_t* text);


    BOOL getFileList(wchar_t *dir, wchar_t** ptrArray, int* count,
                BOOL onlyFilesNumber, BOOL isRecursiveInDirectory);

    BOOL getFileList(wchar_t *dir, wchar_t** ptrArray, int *count,
                BOOL onlyFilesNumber, BOOL isRecursiveInDirectory, wchar_t* filter);

    BOOL getLastWriteTime(wchar_t* filename, wchar_t* wtime, DATE* dtime);

    BOOL getFileSize(wchar_t* filename, unsigned long *size);

    // read and write binary data from / into file
    void readByteFromFile(wchar_t* fName, byte *ptr, int* numBytes);
    void writeByteToFile (wchar_t* fName, byte *ptr, int numBytes);

    // write current items (fileName) into file to use to compare name and date...
    void writeCurrentFileItems(int dataType, const wchar_t* path, const wchar_t* dir);

    // read fileName from file
    // the first element is the timestamp of last sync
    int readFilenameFromFile(int dataType, const wchar_t* path, wchar_t*** ptrArrayFilename);

    /*
    * The key can be a file name so it can contain some special char to be encoded.
    * The method get an array of wchar and overwrite the current key with the encoded one.
    */
    void encodeKey(wchar_t* key);

    /*
    * The key can be a file name so it can contain some special char to be encoded.
    * The method get an array of wchar and overwrite the current key with the encoded one.
    */
    void decodeKey(wchar_t* key);
    char* readTextFromBinaryFileChar(wchar_t* filename);

#endif

