/*
 * Copyright (C) 2003-2007 Funambol, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
 */

//
// @author Marco Magistrali
//

#ifndef INCL_RECURRENCE_EXCEPTION
    #define INCL_RECURRENCE_EXCEPTION

    #include "spdm/spdmutils.h"
    #include "pimstore.h"
    #include "Tlhelp32.h"

    #include <string>
    using namespace std;
    // definitions

class RecurrenceException {

private:

    DATE originalDate;

    DATE start;
    DATE end;

    wstring subject;
    wstring location;
    wstring body;
    long busyStatus;
    BOOL allDayEvent;

    BOOL deleted;

    // used only to monitory the date (debug...)

    wchar_t wstartdate[64];
    wchar_t wenddate[64];
    wchar_t woriginaldate[64];

public:

    RecurrenceException();
    ~RecurrenceException();

    void setOriginalDate(DATE date);
    DATE getOriginalDate() {return originalDate; };

    void setStart(DATE date);
    DATE getStart() {return start; }

    void setEnd(DATE date);
    DATE getEnd() {return end;}

    void setSubject(wstring s);
    wstring getSubject() { return subject; }

    void setLocation(wstring s);
    wstring getLocation() { return location; }

    void setBody(wstring s);
    wstring getBody() { return body; }

    void setBusyStatus(long s);
    BOOL getBusyStatus() {return busyStatus; }

    void setAllDayEvent(BOOL del);
    BOOL getAllDayEvent() {return allDayEvent; }

    void setIsDeleted(BOOL del);
    BOOL isDeleted() { return deleted; }

    BOOL isOriginalEqualsStart();

};

#endif