/*
 * Copyright (C) 2003-2007 Funambol, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
 */

#ifndef INCL_UTILS_RECURRENCE
#define INCL_UTILS_RECURRENCE

#include "spdm/spdmutils.h"
#include "pimstore.h"
#include "Tlhelp32.h"
#include "pim/RecurrenceException.h"

#include <string>
#include <list>
#include <vector>

using namespace std;

// definitions
wstring getRecurrenceTags(IRecurrencePattern* pRecurrence, VARIANT_BOOL isRecurring,
                          int x, int y, OlDefaultFolders olFolder, DATE startdate, BOOL isAllDay);
wstring createExceptions(IRecurrencePattern* pRecurrence, DATE startdate, BOOL isAllday);
wstring createException(IException* pException, DATE startdate, BOOL isAllday);

int convertDayOfWeekMaskBackward(int dayOfWeekMaskSent);
int convertDayOfWeekMaskForward(int dayOfWeekMaskSent);

void parseRecurrenceTags(IRecurrencePattern *pRecurrence, const wchar_t* ptrData,
                         DATE recurrenceStart, int x, int y);
void parseExceptionTags(IRecurrencePattern* pRecurrence, IAppointment* pAppointment,
                        const wchar_t* ptrData, IPOutlookApp* polApp,
                        const wchar_t* path);

BOOL checkAlreadyAnException(IRecurrencePattern* pRecurrence, DATE originalDate, DATE startDate);

vector<RecurrenceException> getExceptionList(IRecurrencePattern* pRecurrence,
                                             const wchar_t* ptrData,
                                             const wchar_t* action);
//void executeException(IRecurrencePattern* pRecurrence, RecurrenceException rec);
//void deleteIntraOccurrences(IRecurrencePattern* pRecurrence, DATE originalDate, DATE startdate);
long createAppointmentFromException(IAppointment* pAppointment, RecurrenceException rec, IPOutlookApp* polApp);
void writeOidToReset(vector<long> oids, const wchar_t* wpath);

#endif