/*
 * Copyright (C) 2003-2007 Funambol, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
 */

/***********************************************************************
 * Email account handling functions
 ***********************************************************************/

#include <windows.h>
#include <stdio.h>
#include <cfgmgrapi.h>
#include <mapidefs.h>
#include <mapicode.h>
#include <mapitags.h>
#include <mapix.h>
#include <mapiutil.h>
#include <cemapi.h>

#define ACCOUNT_KEY L"F9043C85-F6F2-101A-A3C9-08002B2F49FB"
#define ACCOUNT_PARAM_SIZE  256

/**
 * Modify visible name and email address on Funambol Account
 *
 * @param name - the visible name of the user
 * @param replyAddress - the email address to use for the account
 *
 */
HRESULT modifyAccount(const wchar_t* name, const wchar_t* replyAddress);

/**
 * Get Funambol account information
 *
 * @param name - the visible name of the user
 * @param replyAddress - the email address to use for the account
 *
 */
HRESULT getAccountInfoSession(wchar_t* name, wchar_t* replyaddress, IMAPISession* pSession);

/**
* Get the visible name and the email address of the user of the Funambol
* email account.
*
* @param name - the visible name of the user. OUT
* @param replyaddress - the email address of the user. OUT
*/
HRESULT getAccountInfo(wchar_t* name, wchar_t* replyaddress);

/**
* Return true if the Funambol email account exists
*/
BOOL doesFunambolAccountExist();

/**
* Get the GUID of the Funambol email account
*/
wchar_t* getFunambolGUID(IMAPISession* pSession = NULL);
