/*
 * Copyright (C) 2003-2007 Funambol, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
 */
#ifndef INCL_MAIL_CLIENT_DATA
#define INCL_MAIL_CLIENT_DATA
/** @cond WMPLUGIN_MAINCLIENT */
/** @{*/

#include "spds/EmailData.h"

/**
* This class represents the mail item inside the cache file that contains the current
* elements into all folder.
*/

class MailClientData {

    private:

        wchar_t* folder;
        wchar_t* entryId;
        EmailData* emailData;
        int maxMailMessageSize;

        // parameter taken from the configuration
        int currentMessageSizeFilter;

        // parameter to understand if the sync is to download the remainig part of the mail
        bool isSyncInclusive;

    public:

        MailClientData(const wchar_t *id);
        ~MailClientData();

        void setEmailData(EmailData* t);
        EmailData* getEmailData() const;

        const wchar_t* getEntryId() const ;

        void setParent(const wchar_t* t);
        void setParent(wchar_t t);
        const wchar_t* getParent() const ;
        void setMaxMailMessageSize(unsigned long v) { maxMailMessageSize = v; }
        unsigned long getMaxMailMessageSize() { return maxMailMessageSize; }

        void setCurrentMessageSizeFilter(unsigned long v) { currentMessageSizeFilter = v; }
        unsigned long getCurrentMessageSizeFilter() { return currentMessageSizeFilter; }

        void setIsSyncInclusive(bool v) { isSyncInclusive = v; }
        bool getIsSyncInclusive() { return isSyncInclusive; }

};
#endif

