/*
 * Copyright (C) 2003-2007 Funambol, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
 */

#ifndef INCL_MAIL_UTILS
    #define INCL_MAIL_UTILS

#include "base/util/ArrayElement.h"
#include "base/util/ArrayList.h"
#include "base/util/utils.h"
#include "base/Log.h"
#include "client/MailSourceManagementNode.h"

#include "notify/checknet.h"


#include <mapidefs.h>
#include <cemapi.h>

    #define ACCOUNT_NAME  TEXT("Funambol")
    //
    // Custom propertis to store messageID and extra headers
    //
    #define PR_CUSTOM_MESSAGE_ID        PROP_TAG(PT_TSTRING, 0x8010)
    #define PR_CUSTOM_MESSAGE_HEADER    PROP_TAG(PT_TSTRING, 0x8020)

    #define ITEM_ARLEADY_EXISTS         TEXT("Item-arleady-exists")

    #define NO_ACTION_MAIL     0
    #define NEW_MAIL           1
    #define UPDATED_MAIL       2

    #define EXIT_ON_FAILED(_hr)   \
      if (FAILED(_hr))  {  \
        LOG.error("FAILED(%x) at %hs:%d\n", _hr, __FILE__, __LINE__); \
        goto FuncExit; \
      }

    #ifndef RELEASE_OBJ
    #define RELEASE_OBJ(s) \
      if (s != NULL)   \
      {          \
        s->Release();  \
        s = NULL;    \
      }
    #endif //RELEASE_OBJ

    #define INBOX_FOLDER      'I'
    #define OUTBOX_FOLDER     'O'
    #define TRASH_FOLDER      'T'
    #define DRAFT_FOLDER      'D'
    #define SENT_FOLDER       'S'

    wchar_t* c2wc (wchar_t t);
    wchar_t* convertBinaryToWChar(SBinary sbEntry, wchar_t folder);
    char* convertBinaryToChar(SBinary sbEntry, wchar_t folder);
    size_t decodeEntryId(const wchar_t *entryId, char **id);
    ULONG getFolderId(wchar_t t);
    void getFolderToSync(MailSyncSourceConfig &sc, OUT wchar_t* tt);
    char* createMessageID(const wchar_t* entryID);

#endif
