/*
 * Copyright (C) 2003-2007 Funambol, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
 */
#define OUT_MESSAGE_NOT_SENT TEXT("It is impossible to send the email. ")
#define ONE_OUT_MESSAGE_NOT_SENT TEXT("It is impossible to send the email. Please check it and try again.")
#define MORE_OUT_MESSAGE_NOT_SENT TEXT("It is impossible to send the emails. Please check them and try again.")

#define OUT_MESSAGE_TIMEOUT 5

#ifndef INCL_MAINCPP
    #define INCL_MAINCPP

    #include <windows.h>
    #include "base/Log.h"
    #include "spds/constants.h"

    /*
     * Entry point to kickoff the synchronization process, both specifying the
     * sources or not. The default is to make all the configured sources.
     *
     * @param path    : the install path of the SyncClient PIM application on
     *                  the device
     * @param sources : NULL terminated array of strings containing the source
     *                  name of the sources to synchronize
     * @param ids :     NULL terminated array of strings containing the id of the mail
     *                  that must be synched with a INCLUSIVE filter. Note that this parameter
     *                  could be valorized only when there is only a source and this source is mail
     * @param mode:     the sync mode used for the sync if imposed by the client
     */
    DWORD WINAPI synchronize (const wchar_t* path,
                              const wchar_t** sources,
                              const wchar_t** ids,
                              const char* mode);

    /*
    * get the log level set into client properties
    */
    LogLevel getLOGLevel();

    //BOOL startPolling();

    //int startSync(time_t timeout);
    //unsigned long startSyncPid(time_t timeout);
    //int checkPid(long pid);
    DWORD checkStartSync();
    int startProgram(const wchar_t *app, const wchar_t *cmdline);
    //void setNameOfSourceForSlow(const char* ss);
    int operatorNewHandler(size_t size);
#endif