/*
 * Copyright (C) 2003-2007 Funambol, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
 */
// setup.h : main header file for the SETUP DLL
//


#ifndef REGISTRY_H
    #define REGISTRY_H

    void setPropertyValue(const wchar_t*  context, const wchar_t*  prop, const wchar_t* value, bool backup = false);
    wchar_t* readPropertyValue(const wchar_t* fullContext, const wchar_t*  prop);
    void createAllRegistry(bool backup = false);
    void createAllRegistryBackup();
    void deleteAllRegistry();

    void deleteSyncmlTransportRegistry();

    void deleteAllRegistry();

    void createSyncmlTransportRegistry();


    static size_t getLenEncoding(const WCHAR* s);
    char* toMultibyte(const WCHAR *wc);

    bool backupRegistry30();
    bool backupRegistryVersion();
    bool restoreRegistryVersion();
    bool removeBackupRegistryVersion();
    bool removeEntryOfUninstall30(wchar_t* installedName);

    wchar_t** getChildrenNames();

    // set in the backup registry if the previous plug-in is from 3.0 version
    BOOL isFrom30();
    void setFrom30();

#endif
