/*
 * Copyright (C) 2003-2007 Funambol, Inc
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY, TITLE, NONINFRINGEMENT or FITNESS FOR A PARTICULAR
 * PURPOSE.  See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
 * 02111-1307  USA
 */


#include "stdafx.h"

#include <cfgmgrapi.h>
#include "Tlhelp32.h"
#include "mail.h"
#include "registry.h"
#include "Winbase.h"  //-- for createProcess
#include "winreg.h"   //-- for registry key reading
//#include "Aygshell.h"
#define PROGRAM_DIR TEXT("Funambol")

#define MSG_BEFORE_UNINSTALL TEXT("Do you want to keep the emails for the next Funambol Windows Mobile Plug-in installation?")
#define MSG_SYNC_IN_PROGRESS TEXT("Cannot uninstall. Sync is in progress.")
#define MSG_UI_PRESENT TEXT("Cannot uninstall. Funambol Windows Mobile Plug-in is opened.")


#define FILE1 TEXT("mails_I")
#define FILE2 TEXT("mails_O")
#define FILE3 TEXT("mails_D")
#define FILE4 TEXT("mails_S")
#define FILE5 TEXT("mails_T")
#define FILE6 TEXT("appointments.dat")
#define FILE7 TEXT("contacts.dat")
#define FILE8 TEXT("notes.dat")
#define FILE9 TEXT("tasks.dat")
#define FILE10 TEXT("briefcase.dat")
#define FILE11 TEXT("favorites.dat")
#define FILE18 TEXT("appOidToReset.dat")


#define FILE12 TEXT("\\AccountLog.txt")
#define FILE13 TEXT("\\synclog.txt")
#define FILE14 TEXT("\\notlstnr.txt")
#define FILE15 TEXT("\\wap_push.txt")
#define FILE16 TEXT("\\wap.txt")
#define FILE17 TEXT("\\syncresults.txt")

int ret = 0;

int FileCopy ( const char *src, const char *dst );
int FileCopy ( const wchar_t *src, const wchar_t *dst );

const wchar_t *getProgramPath();

wchar_t* getTempFileDir() {

    wchar_t* internalPath = new wchar_t[256];
    SHGetSpecialFolderPath(NULL, internalPath, CSIDL_WINDOWS, FALSE);
    wcscat(internalPath, TEXT("\\"));
    wcscat(internalPath, TEXT("tempFunFiles"));
    return internalPath;
}

void createFileForUpdate() {
    FILE* funinstall = fopen("\\__uninstall_Fun_plugin__", "a+");
    fputs ("uninstall", funinstall);
    fclose(funinstall);
}

void deleteFileForUpdate() {

    DeleteFile(TEXT("\\__uninstall_Fun_plugin__"));
}

bool existsFileForUpdate() {
    FILE* f = fopen("\\__uninstall_Fun_plugin__", "r");
    bool ret = false;
    if (f) {
        ret = true;
        fclose(f);
    }
    return ret;
}

BOOL removeFileInDir(const wchar_t* dir) {
    WIN32_FIND_DATA FileData;

    wchar_t internalPath[256];
    wcscpy(internalPath, dir);

    HANDLE hFind;
    wchar_t toFind    [512];
    wchar_t szNewPath [512];
    wchar_t filterPattern [256];

    szNewPath[0] =   0;

    DWORD dwAttrs;
    BOOL fFinished = FALSE;

    wsprintf(filterPattern, TEXT("*.*"));

    wsprintf(toFind, TEXT("%s/%s"), internalPath, filterPattern);

    hFind = FindFirstFile(toFind, &FileData);

    if (hFind != INVALID_HANDLE_VALUE) {

        while (!fFinished) {

            wsprintf(szNewPath, TEXT("%s/%s"), internalPath, FileData.cFileName);

            dwAttrs = GetFileAttributes(szNewPath);

            if (dwAttrs == FILE_ATTRIBUTE_DIRECTORY) { }

            else {
                  DeleteFile(szNewPath);
            }

            if (!FindNextFile(hFind, &FileData)) {
                if (GetLastError() == ERROR_NO_MORE_FILES) {
                    fFinished = TRUE;
                }
                else  {
                    return FALSE;
                }
            }
        }

        FindClose(hFind);
    }
    return true;
}

BOOL isWindowsMobile5() {

    OSVERSIONINFO OSVersionInfo;
    OSVersionInfo.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
    GetVersionEx(&OSVersionInfo);

    if (OSVersionInfo.dwMajorVersion >= 5)
        return true;
    else
        return false;
}

bool backupFiles() {

    wchar_t* internalPath = getTempFileDir();
    if (internalPath == NULL)
        return false;

    const wchar_t* path = getProgramPath();

    CreateDirectory(internalPath, NULL);
    // clean if there are some dirty files
    removeFileInDir(internalPath);

    wchar_t src[255]; wchar_t dst[255];

    wsprintf(src, TEXT("%s\\%s"), path, FILE1);
    wsprintf(dst, TEXT("%s\\%s"), internalPath, FILE1);
    FileCopy(src, dst);

    wsprintf(src, TEXT("%s\\%s"), path, FILE2);
    wsprintf(dst, TEXT("%s\\%s"), internalPath, FILE2);
    FileCopy(src, dst);

    wsprintf(src, TEXT("%s\\%s"), path, FILE3);
    wsprintf(dst, TEXT("%s\\%s"), internalPath, FILE3);
    FileCopy(src, dst);

    wsprintf(src, TEXT("%s\\%s"), path, FILE4);
    wsprintf(dst, TEXT("%s\\%s"), internalPath, FILE4);
    FileCopy(src, dst);

    wsprintf(src, TEXT("%s\\%s"), path, FILE5);
    wsprintf(dst, TEXT("%s\\%s"), internalPath, FILE5);
    FileCopy(src, dst);

    wsprintf(src, TEXT("%s\\%s"), path, FILE6);
    wsprintf(dst, TEXT("%s\\%s"), internalPath, FILE6);
    FileCopy(src, dst);

    wsprintf(src, TEXT("%s\\%s"), path, FILE7);
    wsprintf(dst, TEXT("%s\\%s"), internalPath, FILE7);
    FileCopy(src, dst);

    wsprintf(src, TEXT("%s\\%s"), path, FILE8);
    wsprintf(dst, TEXT("%s\\%s"), internalPath, FILE8);
    FileCopy(src, dst);

    wsprintf(src, TEXT("%s\\%s"), path, FILE9);
    wsprintf(dst, TEXT("%s\\%s"), internalPath, FILE9);
    FileCopy(src, dst);

    wsprintf(src, TEXT("%s\\%s"), path, FILE10);
    wsprintf(dst, TEXT("%s\\%s"), internalPath, FILE10);
    FileCopy(src, dst);

    wsprintf(src, TEXT("%s\\%s"), path, FILE11);
    wsprintf(dst, TEXT("%s\\%s"), internalPath, FILE11);
    FileCopy(src, dst);

    wsprintf(src, TEXT("%s\\%s"), path, FILE18);
    wsprintf(dst, TEXT("%s\\%s"), internalPath, FILE18);
    FileCopy(src, dst);

    if (internalPath)
        delete [] internalPath;
    return true;
}


// return true for ok
bool backupFrom30() {
    backupFiles();
    // copy registry settings
    backupRegistry30();
    return true;
}


// return true for ok
bool backupClientVersion() {

    backupFiles();
    backupRegistryVersion();

    return true;
}

bool existsBackup() {

    // to check for the registry backup
    HKEY key = NULL;
    DWORD res;
    bool ret = false;

    res = RegOpenKeyEx(
            HKEY_LOCAL_MACHINE,
            TEXT("Software\\FunambolBkp\\SyncclientPIM"),
            0,
            NULL,
            &key
            );

    if (key != 0) {
        RegCloseKey(key);
    }

    if (res == ERROR_SUCCESS) {
        ret = true;
    } else {
        //MessageBox (NULL, TEXT("no backup"), TEXT ("Alert"), MB_SETFOREGROUND | MB_ICONHAND | MB_OK);
    }

    return ret;
}

bool restoreFiles() {

    wchar_t* internalPath = getTempFileDir();
    if (internalPath == NULL)
        return false;
    const wchar_t* path = getProgramPath();

    wchar_t src[255]; wchar_t dst[255];

    wsprintf(dst, TEXT("%s\\%s"), path, FILE1);
    wsprintf(src, TEXT("%s\\%s"), internalPath, FILE1);
    FileCopy(src, dst);

    wsprintf(dst, TEXT("%s\\%s"), path, FILE2);
    wsprintf(src, TEXT("%s\\%s"), internalPath, FILE2);
    FileCopy(src, dst);

    wsprintf(dst, TEXT("%s\\%s"), path, FILE3);
    wsprintf(src, TEXT("%s\\%s"), internalPath, FILE3);
    FileCopy(src, dst);

    wsprintf(dst, TEXT("%s\\%s"), path, FILE4);
    wsprintf(src, TEXT("%s\\%s"), internalPath, FILE4);
    FileCopy(src, dst);

    wsprintf(dst, TEXT("%s\\%s"), path, FILE5);
    wsprintf(src, TEXT("%s\\%s"), internalPath, FILE5);
    FileCopy(src, dst);

    wsprintf(dst, TEXT("%s\\%s"), path, FILE6);
    wsprintf(src, TEXT("%s\\%s"), internalPath, FILE6);
    FileCopy(src, dst);

    wsprintf(dst, TEXT("%s\\%s"), path, FILE7);
    wsprintf(src, TEXT("%s\\%s"), internalPath, FILE7);
    FileCopy(src, dst);

    wsprintf(dst, TEXT("%s\\%s"), path, FILE8);
    wsprintf(src, TEXT("%s\\%s"), internalPath, FILE8);
    FileCopy(src, dst);

    wsprintf(dst, TEXT("%s\\%s"), path, FILE9);
    wsprintf(src, TEXT("%s\\%s"), internalPath, FILE9);
    FileCopy(src, dst);

    wsprintf(dst, TEXT("%s\\%s"), path, FILE10);
    wsprintf(src, TEXT("%s\\%s"), internalPath, FILE10);
    FileCopy(src, dst);

    wsprintf(dst, TEXT("%s\\%s"), path, FILE11);
    wsprintf(src, TEXT("%s\\%s"), internalPath, FILE11);
    FileCopy(src, dst);

    wsprintf(dst, TEXT("%s\\%s"), path, FILE18);
    wsprintf(src, TEXT("%s\\%s"), internalPath, FILE18);
    FileCopy(src, dst);

    if (internalPath)
        delete [] internalPath;
    return true;
}

// return true for ok
bool restoreClientVersion() {

    restoreFiles();
    restoreRegistryVersion();

    return true;
}

bool removeBackupVersion() {

    removeBackupRegistryVersion();

    wchar_t* internalPath = getTempFileDir();
    if (internalPath == NULL)
        return false;
    removeFileInDir(internalPath);
    RemoveDirectory(internalPath); // remove tmp empty dir

    return true;
}

//use to delete the funambol 3.0 installation files
bool removeAllFileFrom30() {

    const wchar_t* path = getProgramPath();

    removeFileInDir(path);
    wchar_t internalPath[256];
    wsprintf(internalPath, TEXT("%sdocs"), path);

    removeFileInDir(internalPath);
    RemoveDirectory(internalPath);
    return true;

}

/****************************************************************/
// retrieve the Funambol program path and set it in a static
// buffer. Return the buffer
const wchar_t *getProgramPath()
{
    static wchar_t path[MAX_PATH] = TEXT("");
    //wchar_t* ret_path = NULL;
    HKEY key = NULL;
    long err = 0;
    ULONG dim = 0;
    DWORD type =0;

    RegOpenKeyEx(HKEY_LOCAL_MACHINE,_T("\\Software\\Funambol\\SyncclientPIM"),0,0, &key );

    err = RegQueryValueEx(key, _T("path"),  NULL, NULL, NULL, &dim  );
    if (err == ERROR_SUCCESS)
    {
        if (dim > 0)
        {
            wchar_t *buf = new wchar_t[dim + 1];
            memset(buf, 0, (dim+1)*sizeof(wchar_t));
            err = RegQueryValueEx( key, _T("path"),  NULL, NULL, (UCHAR*)buf, &dim);
            RegCloseKey(key);
            wcscpy(path, buf);
            //ret_path = _wcsdup(buf);
            if(buf)
                {delete[]buf; buf=NULL;}
        }
        else
            RegCloseKey(key);
    }
    else
    {
        //-- reg value not found
        if (!path[0])
        {
            SHGetSpecialFolderPath(NULL, path, CSIDL_PROGRAM_FILES , FALSE);
            wcscat(path, TEXT("\\"));
            wcscat(path, PROGRAM_DIR);
            //ret_path = _wcsdup(path);
        }
    }
    return path;
}

/**
 * Start a command in a new process and return the pid
 * or 0 in case of error.
 */
unsigned long startprogram(const wchar_t *app, const wchar_t *cmdline)
{
    const wchar_t *path = getProgramPath();
    PROCESS_INFORMATION procinfo;
    unsigned long ret_code=0;

    wchar_t *cmd = new wchar_t[wcslen(path)+wcslen(app)+5];
    wsprintf(cmd, TEXT("%s\\%s"), path, app);

    if( CreateProcess( cmd, cmdline,
                       NULL, NULL, FALSE, 0,
                       NULL, NULL, NULL, &procinfo ) ) {
        ret_code =  procinfo.dwProcessId;
    }
    else
        ret_code= 0;

    if(path)
        {path=NULL;}
    if(cmd)
    {delete [] cmd; cmd=NULL;}

    return ret_code;
}

void deregister()
{
    startprogram(TEXT("handleservice.exe"), TEXT("deregister"));
}

void deregisterSMS()
{
    startprogram(TEXT("startsync.exe"), TEXT("deregister"));
}

void registerPush()
{
    startprogram(TEXT("handleservice.exe"), TEXT("register"));
}

void registerSMS()
{
    startprogram(TEXT("startsync.exe"), TEXT("register"));
}

void registerCradle() {
    startprogram(TEXT("handleservice.exe"), TEXT("registerCradle"));
}

void deregisterCradle() {
    startprogram(TEXT("handleservice.exe"), TEXT("deregisterCradle"));
}

void restoreNotificationSettings() {

    wchar_t* value = readPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM"), TEXT("push"));
    if (value && wcscmp(value, TEXT("0")) != 0) {
        registerPush();
    }
    if (value) { delete [] value; value = NULL; }

    value = readPropertyValue(TEXT("Software\\Funambol\\SyncclientPIM"), TEXT("sms"));
    if (value && wcscmp(value, TEXT("0")) != 0) {
        registerSMS();
    }

}

BOOL deleteFilesInRoot() {
    DeleteFile(FILE12);
    DeleteFile(FILE13);
    DeleteFile(FILE14);
    DeleteFile(FILE15);
    DeleteFile(FILE16);
    DeleteFile(FILE17);
    return true;
}


BOOL deleteFiles() {

    WIN32_FIND_DATA FileData;

    HANDLE hFind;
    wchar_t toFind    [512];
    wchar_t szNewPath [512];
    wchar_t filterPattern [256];
    wchar_t dir       [512];

    BOOL ret = TRUE;
    szNewPath[0] =   0;
    int lung = 0;

    DWORD dwAttrs;

    BOOL fFinished = FALSE;
    wcscpy(dir, getProgramPath());
    wsprintf(filterPattern, TEXT("*.*"));

    wsprintf(toFind, TEXT("%s/%s"), dir, filterPattern);

    hFind = FindFirstFile(toFind, &FileData);

    if (hFind != INVALID_HANDLE_VALUE) {

        while (!fFinished) {

            wsprintf(szNewPath, TEXT("%s/%s"), dir, FileData.cFileName);

            dwAttrs = GetFileAttributes(szNewPath);

            if (dwAttrs == FILE_ATTRIBUTE_DIRECTORY) { }

            else {
                if (   (wcsstr(szNewPath, FILE1) != NULL) ||
                       (wcsstr(szNewPath, FILE2) != NULL) ||
                       (wcsstr(szNewPath, FILE3) != NULL) ||
                       (wcsstr(szNewPath, FILE4) != NULL) ||
                       (wcsstr(szNewPath, FILE5) != NULL) ||
                       (wcsstr(szNewPath, FILE6) != NULL) ||
                       (wcsstr(szNewPath, FILE7) != NULL) ||
                       (wcsstr(szNewPath, FILE8) != NULL) ||
                       (wcsstr(szNewPath, FILE9) != NULL) ||
                       (wcsstr(szNewPath, FILE10) != NULL) ||
                       (wcsstr(szNewPath, FILE11) != NULL) ||
                       (wcsstr(szNewPath, FILE18) != NULL)
                       ) {

                        DeleteFile(szNewPath);
                }
            }

            if (!FindNextFile(hFind, &FileData)) {
                if (GetLastError() == ERROR_NO_MORE_FILES) {
                    fFinished = TRUE;
                }
                else  {
                    return FALSE;
                }
            }
        }

        FindClose(hFind);
    }

    deleteFilesInRoot();

    //RemoveDirectory(dir);
    return ret;
}

BOOL deleteDirectory() {

    wchar_t dir       [512];
    wcscpy(dir, getProgramPath());
    RemoveDirectory(dir);
    return TRUE;
}

BOOL createDirectory() {

    wchar_t dir       [512];
    wcscpy(dir, getProgramPath());
    CreateDirectory(dir, NULL);
    return TRUE;
}

DWORD getProcessPid(const wchar_t *processName)
{
    PROCESSENTRY32 lppe;
    BOOL next = TRUE;
    HANDLE hProcess = 0;
    DWORD pid = 0;

    HANDLE hSnapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);

    if (hSnapshot == INVALID_HANDLE_VALUE)
        return 0;

    lppe.dwSize = sizeof( PROCESSENTRY32 );

    if (!Process32First(hSnapshot, &lppe))
        return 0;

    if (wcsstr(lppe.szExeFile, processName) != NULL) {
        pid = lppe.th32ProcessID;
    }

    do {
        next = Process32Next(hSnapshot, &lppe);

        if (!next)
            break;

        if (wcsstr(lppe.szExeFile, processName) != NULL ) {
            pid = lppe.th32ProcessID;
            break;
        }

    } while(next);

    if (hSnapshot)
        CloseToolhelp32Snapshot(hSnapshot);
    CloseHandle(hProcess);
    return pid;
}


DWORD checkSyncInProgress(){
    DWORD pid = 0;
    // Try to create the mutex
    HANDLE hMutex = CreateMutex(NULL, TRUE, TEXT("FunSyncInProgress") );
    if(hMutex){
        if(GetLastError() == ERROR_ALREADY_EXISTS){
            pid = getProcessPid( TEXT("startsync.exe") );
        }
        CloseHandle( hMutex );
    }
    return pid;
}

DWORD checkUI()
{
    DWORD pid = 0;
    pid = getProcessPid( TEXT("Funambol.exe") );
    return pid;
}
int closeMail() {
    DWORD out = 0;
    PROCESSENTRY32 lppe;
    BOOL next = TRUE;
    HANDLE hProcess = 0;

    HANDLE hSnapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0); // 0 is however ignored

    if (hSnapshot == INVALID_HANDLE_VALUE)
        return 0;

    lppe.dwSize = sizeof( PROCESSENTRY32 );

    if (!Process32First(hSnapshot, &lppe))
        return 1;

    if (wcsstr(lppe.szExeFile, TEXT("tmail.exe")) != NULL) {
        hProcess = OpenProcess(0, FALSE, lppe.th32ProcessID);
        TerminateProcess(hProcess, -1);
        goto exit;
    }

    do {
        next = Process32Next(hSnapshot, &lppe);

        if (!next)
            break;

        if (wcsstr(lppe.szExeFile, TEXT("tmail.exe")) != NULL ) {
            hProcess = OpenProcess(0, FALSE, lppe.th32ProcessID);
            TerminateProcess(hProcess, -1);
            goto exit;
        }

    } while(next);

exit:
    if (hSnapshot)
        CloseToolhelp32Snapshot(hSnapshot);
    CloseHandle(hProcess);
    return 0;

}

int closeFunambol() {
    DWORD out = 0;
    PROCESSENTRY32 lppe;
    BOOL next = TRUE;
    HANDLE hProcess = 0;

    HANDLE hSnapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0); // 0 is however ignored

    if (hSnapshot == INVALID_HANDLE_VALUE)
        return 0;

    lppe.dwSize = sizeof( PROCESSENTRY32 );

    if (!Process32First(hSnapshot, &lppe))
        return 1;

    if (wcsstr(lppe.szExeFile, TEXT("Funambol.exe")) != NULL ||
        wcsstr(lppe.szExeFile, TEXT("startsync.exe")) != NULL) {
        hProcess = OpenProcess(0, FALSE, lppe.th32ProcessID);
        TerminateProcess(hProcess, -1);
        CloseHandle(hProcess);
        //goto exit;
    }

    do {
        next = Process32Next(hSnapshot, &lppe);

        if (!next)
            break;

        if (wcsstr(lppe.szExeFile, TEXT("Funambol.exe")) != NULL ||
            wcsstr(lppe.szExeFile, TEXT("startsync.exe")) != NULL) {
            hProcess = OpenProcess(0, FALSE, lppe.th32ProcessID);
            TerminateProcess(hProcess, -1);
            CloseHandle(hProcess);
            //goto exit;
        }

    } while(next);

//exit:
    if (hSnapshot)
        CloseToolhelp32Snapshot(hSnapshot);
    CloseHandle(hProcess);
    return 0;

}

int closeFunambol30() {
    DWORD out = 0;
    PROCESSENTRY32 lppe;
    BOOL next = TRUE;
    HANDLE hProcess = 0;

    HANDLE hSnapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0); // 0 is however ignored

    if (hSnapshot == INVALID_HANDLE_VALUE)
        return 0;

    lppe.dwSize = sizeof( PROCESSENTRY32 );

    if (!Process32First(hSnapshot, &lppe))
        return 1;

    if (wcsstr(lppe.szExeFile, TEXT("pvbload.exe")) != NULL ) {
        hProcess = OpenProcess(0, FALSE, lppe.th32ProcessID);
        TerminateProcess(hProcess, -1);
        CloseHandle(hProcess);
        //goto exit;
    }

    do {
        next = Process32Next(hSnapshot, &lppe);

        if (!next)
            break;

        if (wcsstr(lppe.szExeFile, TEXT("pvbload.exe")) != NULL) {
            hProcess = OpenProcess(0, FALSE, lppe.th32ProcessID);
            TerminateProcess(hProcess, -1);
            CloseHandle(hProcess);
            //goto exit;
        }

    } while(next);

//exit:
    if (hSnapshot)
        CloseToolhelp32Snapshot(hSnapshot);
    CloseHandle(hProcess);
    return 0;

}

int FileCopy ( const wchar_t *src, const wchar_t *dst ) {

    char* s = toMultibyte(src);
    char* d = toMultibyte(dst);

    int ret = FileCopy(s, d);

    if (s) { delete [] s; }
    if (d) { delete [] d; }

    return ret;

}
int FileCopy ( const char *src, const char *dst ) {

int COPY_ERROR  = -1;
int COPY_OK     =  0;
int BUFSZ       = 16000;

char            *buf;
FILE            *fi;
FILE            *fo;
unsigned        amount;
unsigned        written;
int             result = COPY_OK;

buf = new char[BUFSZ];

fi = fopen( src, "rb" );
if  (fi == NULL) {
    return COPY_ERROR;
}

fo = fopen( dst, "wb" );

if  ((fi == NULL) || (fo == NULL) ) {
    result = COPY_ERROR;
    if (fi != NULL) fclose(fi);
    if (fo != NULL) fclose(fo);
}

if (result == COPY_OK) {
    do {
        amount = fread( buf, sizeof(char), BUFSZ, fi );
        if (amount) {
            written = fwrite( buf, sizeof(char), amount, fo );
            if (written != amount) {
                result = COPY_ERROR; // out of disk space or some other disk err?
            }
        }
    } // when amount read is < BUFSZ, copy is done
    while ((result == COPY_OK) && (amount == BUFSZ));

    fclose(fi);
    fclose(fo);
}

delete [] buf;

return result;

}

const wchar_t *getWindowsPath()
{
    static wchar_t winpath[MAX_PATH] = TEXT("");
    if (!winpath[0])
    {
        SHGetSpecialFolderPath(NULL, winpath, CSIDL_WINDOWS , FALSE);
        wcscat(winpath, TEXT("\\"));
    }
    return winpath;
}

void createBriefcaseFolder()
{
    /*  create a briefcase directory under
        My Documents and set it by default. It must not be deleted during the uninstall process.
    */

    LPTSTR dir= new WCHAR[256];
    SHGetSpecialFolderPath(NULL,dir, CSIDL_PERSONAL, FALSE);
    wcscat(dir,_T("\\briefcase"));
    CreateDirectory(dir,NULL);

    HKEY key = NULL;
    long err = 0;
    DWORD type =0;

    RegOpenKeyEx(HKEY_LOCAL_MACHINE,_T("\\Software\\Funambol\\SyncclientPIM\\spds\\sources\\briefcase"),0,0, &key );
    err = RegSetValueEx(key, _T("dir"),  NULL, REG_SZ, (BYTE*)dir, (wcslen(dir)+1)*sizeof(wchar_t));
    if (err == ERROR_SUCCESS)
    {
    }
    RegCloseKey(key);

    if(dir)
        { delete [] dir; dir = NULL;  }

   // startprogram(_T("handleservice.exe"), _T("briefcase"));
}


int existsPreviousInstalledVersion30(wchar_t* nameToRemove) {

    wchar_t** programs = getChildrenNames();
    // there is nothing installed on the device
    if (programs == NULL)
        return 0;

    int j = 0;

    for (j = 0; programs[j] != NULL; j++) {
        if ((wcsstr(programs[j], TEXT("Funambol Windows"))) != NULL ) {
            wcscpy(nameToRemove, programs[j]);
            ret = 1;  // version 3.0
            break;
        }
        else if ((wcsstr(programs[j], TEXT("Funambol P"))) != NULL ) {
            wcscpy(nameToRemove, programs[j]);
            ret = 2;  // version 3.1 of the smartphone
            break;
        }
    }

    for (j = 0; programs[j] != NULL; j++) {
        delete [] programs[j];
    }
    delete programs;

    if (wcslen(nameToRemove) > 0)
        return ret;
    else
        return 0;

}

/*
* This function has problem with the 2003 version and the setup freezes

int existsPreviousInstalledVersion30(wchar_t* nameToRemove) {

    int ret = 0;
    int MAX_CICLE = 50;
    wchar_t installedName[50];
    memset(installedName, 0, 50*sizeof(wchar_t));

    wchar_t uninstalledVersion[] = TEXT("<wap-provisioningdoc>  \
                                        <characteristic-query type=\"UnInstall\"> \
                                        </characteristic-query> </wap-provisioningdoc>");
    wchar_t* out = NULL;
    wchar_t* ptr = NULL;

    DMProcessConfigXML(uninstalledVersion, CFGFLAG_PROCESS, &out);

    if (out == NULL)
        return 0;

    if ((ptr = wcsstr(out, TEXT("Funambol Windows"))) != NULL ) {

        int i = 0;
        for (i = 0; i < MAX_CICLE; i++) {
            if (ptr[i] == '"')
                break;
        }
        if (i != MAX_CICLE - 1)
            wcsncpy(installedName, ptr, i);
        ret = 1;  // version 3.0
    }
    else if ((ptr = wcsstr(out, TEXT("Funambol P"))) != NULL ) {

        int i = 0;
        for (i = 0; i < MAX_CICLE; i++) {
            if (ptr[i] == '"')
                break;
        }
        if (i != MAX_CICLE - 1)
            wcsncpy(installedName, ptr, i);

        ret = 2; // version 3.1 of the smartphone
    }

    delete [] out; out = NULL;

    if (wcslen(installedName) > 0) {
        wcscpy(nameToRemove, installedName);
        return ret;
    }
    else
        return 0;
}

*/

/*************************************************************************************/
// **************************************************************************
// Function Name: Install_Init
//
// Purpose: processes the push message.
//
// Arguments:
//    IN HWND hwndParent  handle to the parent window
//    IN BOOL fFirstCall  indicates that this is the first time this function is being called
//    IN BOOL fPreviouslyInstalled  indicates that the current application is already installed
//    IN LPCTSTR pszInstallDir  name of the user-selected install directory of the application
//
// Return Values:
//    codeINSTALL_INIT
//    returns install status
//
// Description:
//    The Install_Init function is called before installation begins.
//    User will be prompted to confirm installation.
// **************************************************************************
SETUP_API codeINSTALL_INIT Install_Init(
    HWND        hwndParent,
    BOOL        fFirstCall,     // is this the first time this function is being called?
    BOOL        fPreviouslyInstalled,
    LPCTSTR     pszInstallDir
    )
{
    //
    // This function could be called to force to close the email process
    //
    deregister();
    deregisterSMS();
    deregisterCradle();
    closeMail();
    closeFunambol();

    int res = 0;
    wchar_t nameToRemove [128];
    memset(nameToRemove, 0, 128*sizeof(wchar_t));

    if (fFirstCall) {
        //MessageBox (NULL, TEXT("fFirstCall yes"), TEXT ("Alert"), MB_SETFOREGROUND | MB_ICONHAND | MB_OK);
    } else {
        //MessageBox (NULL, TEXT("fFirstCall no"), TEXT ("Alert"), MB_SETFOREGROUND | MB_ICONHAND | MB_OK);
        return codeINSTALL_INIT_CONTINUE;
    }

    if (fPreviouslyInstalled) {
        // copy the registry keys with their configurations
        backupClientVersion();
        createFileForUpdate();
        //
    } else if ((res = existsPreviousInstalledVersion30(nameToRemove)) > 0) {

        if (res == 1) { // it is a 3.0 component
            closeFunambol30();
            backupFrom30();
            //setFrom30();
            removeAllFileFrom30();
        }
        else if (res == 2) { // it is a 3.1.3 component
            backupClientVersion();
        }

        // it removes the uninstall link from the list of uninstall programs
        removeEntryOfUninstall30(nameToRemove);
        deleteFilesInRoot();
    }
    else {
        createAllRegistry();
        createSyncmlTransportRegistry();
    }

    //MessageBox (NULL, TEXT("Exit install init"), TEXT ("Alert"), MB_SETFOREGROUND | MB_ICONHAND | MB_OK);

    return codeINSTALL_INIT_CONTINUE;
}


// **************************************************************************
// Function Name: Install_Exit
//
// Purpose: processes the push message.
//
// Arguments:
//    IN HWND hwndParent  handle to the parent window
//    IN LPCTSTR pszInstallDir  name of the user-selected install directory of the application
//
// Return Values:
//    codeINSTALL_EXIT
//    returns install status
//
// Description:
//    Register query client with the PushRouter as part of installation.
//    Only the first two parameters really count.
// **************************************************************************
SETUP_API codeINSTALL_EXIT Install_Exit(
    HWND    hwndParent,
    LPCTSTR pszInstallDir,      // final install directory
    WORD    cFailedDirs,
    WORD    cFailedFiles,
    WORD    cFailedRegKeys,
    WORD    cFailedRegVals,
    WORD    cFailedShortcuts
    )
{
    //BOOL previousIs30 = isFrom30();
    //MessageBox (NULL, TEXT("install exit"), TEXT ("Alert"), MB_SETFOREGROUND | MB_ICONHAND | MB_OK);
    if (!existsFileForUpdate()) {
        startprogram(_T("handleservice.exe"), _T("createAccount"));
        createBriefcaseFolder();
    }
    if (existsBackup()) {
        restoreClientVersion();
        removeBackupVersion();
    }
    deleteFileForUpdate();
    restoreNotificationSettings();
    /*
    if (previousIs30 && isWindowsMobile5()) {
        int ret = MessageBox (NULL, TEXT("In order to apply all changes is recommended to reboot the device. Do you want to do now?"), TEXT ("Alert"), MB_SETFOREGROUND | MB_ICONHAND | MB_YESNO);
        if (ret == IDYES) {
            ExitWindowsEx(EWX_REBOOT, 0);
        }

    }
    */

    return codeINSTALL_EXIT_DONE;
}


// **************************************************************************
// Function Name: Uninstall_Init
//
// Purpose: processes the push message.
//
// Arguments:
//    IN HWND hwndParent  handle to the parent window
//    IN LPCTSTR pszInstallDir  name of the user-selected install directory of the application
//
// Return Values:
//    codeUNINSTALL_INIT
//    returns uninstall status
//
// Description:
//    Query the device data using the query xml in the push message,
//    and send the query results back to the server.
// **************************************************************************
SETUP_API codeUNINSTALL_INIT Uninstall_Init(
    HWND        hwndParent,
    LPCTSTR     pszInstallDir
    )
{
    //MessageBox (NULL, TEXT("uninstall init"), TEXT ("Alert"), MB_SETFOREGROUND | MB_ICONHAND | MB_OK);

    if (!existsFileForUpdate()) {
        /*
        * Modification to uninstall procedure. The question to the user is suppressed.
        * The mail are kept automatically for the upgrade procedure and delete during the
        * uninstall. TO DO: clean the code....
        */
        //ret = MessageBox (NULL, MSG_BEFORE_UNINSTALL, TEXT ("Funambol Alert"), MB_SETFOREGROUND | MB_ICONQUESTION | MB_YESNO);
        ret = IDNO;

        const wchar_t* windows_path = getWindowsPath();
        char path1[256] ;
        wcstombs(path1, windows_path, wcslen(windows_path));
        char app[256+25];
        char app2[256+25];

        sprintf(app,"%s%s",path1,"\\syncmltransport.dll");
        sprintf(app2,"%s%s",path1,"\\syncmltransport2.dll");
        FileCopy(app, app2);

        //ret = MessageBox (NULL, MSG_BEFORE_UNINSTALL, TEXT ("Funambol Alert"), MB_SETFOREGROUND | MB_ICONQUESTION | MB_YESNO);
        if (ret == IDNO) {
            startprogram( _T("handleservice.exe"), _T("deleteAccount"));
        } else {
            //MessageBox (NULL, TEXT("IDYES"), TEXT ("Debug eVC"), MB_SETFOREGROUND |MB_OK);
        }
        deregisterCradle();
    }
    /*
    * This section is put at the bottom because the deregisterSMS has some bad issue
    * on certain smartphone wm5 if there is a messagebox to show
    */
    closeMail();
    closeFunambol();
    deregister();
    deregisterSMS();

    deleteFiles();

    //MessageBox (NULL, TEXT("Uninstall_Init exit"), TEXT ("Alert"), MB_SETFOREGROUND | MB_ICONHAND | MB_OK);
    return codeUNINSTALL_INIT_CONTINUE;
}


// **************************************************************************
// Function Name: Uninstall_Exit
//
// Purpose: processes the push message.
//
// Arguments:
//    IN HWND hwndParent  handle to the parent window
//
// Return Values:
//    codeUNINSTALL_EXIT
//    returns uninstall status
//
// Description:
//    Query the device data using the query xml in the push message,
//    and send the query results back to the server.
// **************************************************************************
SETUP_API codeUNINSTALL_EXIT Uninstall_Exit(
    HWND    hwndParent
    )
{
    //MessageBox (NULL, TEXT("uninstall exit"), TEXT ("Alert"), MB_SETFOREGROUND | MB_ICONHAND | MB_OK);

    if (!existsFileForUpdate()) {
        const wchar_t* path = getWindowsPath();
        char path1[256] ;
        memset(path1, 0, 256*(sizeof(char)));
        wcstombs(path1, path, wcslen(path));
        char app[256+25];
        char app2[256+25];
        memset(app, 0, 256+25*(sizeof(char)));

        sprintf(app,"%s%s",path1,"syncmltransport.dll");
        sprintf(app2,"%s%s",path1,"syncmltransport2.dll");

        if (ret == IDNO)
        {
            deleteSyncmlTransportRegistry();
            deleteAllRegistry();
            deleteDirectory();
        }
        else
        {

            FileCopy(app2, app);
            deleteFilesInRoot();
        }

        wchar_t app2_wide[256+25];
        wsprintf(app2_wide,_T("%s%s"),path,_T("\\syncmltransport2.dll"));
        DeleteFile(app2_wide);
        if(path)
        { path=NULL; }
    } else {
        deleteAllRegistry();
        deleteFilesInRoot();
    }
    deleteFileForUpdate();

    return codeUNINSTALL_EXIT_DONE;
}


